package com.supervision.exception;

import org.springframework.http.HttpStatus;

public class ItemExtractException extends RuntimeException {
    /**
     * 异常编码
     */
    private final Integer code;

    /**
     * 异常信息
     */
    private final String message;

    public ItemExtractException(Throwable cause) {
        super(cause);
        this.code = HttpStatus.INTERNAL_SERVER_ERROR.value();
        this.message = null;

    }

    public ItemExtractException(Throwable cause, String message) {
        super(cause);
        this.code = HttpStatus.INTERNAL_SERVER_ERROR.value();
        this.message = message;

    }

    public ItemExtractException(String message) {
        this.code = HttpStatus.INTERNAL_SERVER_ERROR.value();
        this.message = message;
    }

    public ItemExtractException(String message, Integer code) {
        this.message = message;
        this.code = code;
    }

    public ItemExtractException(String message, Throwable e) {
        super(message, e);
        this.code = HttpStatus.INTERNAL_SERVER_ERROR.value();
        this.message = message;
    }

    @Override
    public String getMessage() {
        return message;
    }

    public Integer getCode() {
        return code;
    }
}
