package com.supervision.controller;

import cn.hutool.core.map.MapUtil;
import cn.hutool.json.JSONUtil;
import com.supervision.handler.graph.FindConditionPathHandler;
import com.supervision.ngbatis.dao.CommonQueryDao;
import com.supervision.ngbatis.dao.tag.ItemBranchDao;
import com.supervision.ngbatis.domain.tag.Condition;
import com.supervision.ngbatis.domain.tag.ItemBranch;
import com.supervision.ngbatis.domain.tag.ItemLeaf;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping("test")
@RequiredArgsConstructor
public class TestController {

    @Resource
    private ItemBranchDao itemBranchDao;

    private final FindConditionPathHandler findConditionPathHandler;

    @Resource
    private CommonQueryDao commonQueryDao;

    @GetMapping("testInsert")
    public void testInsert() {
        ItemBranch itemBranch = new ItemBranch();
        itemBranch.setItemName("退休");
        itemBranchDao.insert(itemBranch);
    }

    @GetMapping("testQuery")
    public List<ItemBranch> testQuery() {
        Map<String, Object> param = MapUtil.builder(new HashMap<String, Object>()).put("item_name", "退休").build();
        return itemBranchDao.selectByMap(param);
    }

    @GetMapping("findNextConditionByConditionEdge")
    public void findNextConditionByConditionEdge(){
        List<Condition> nextConditionByConditionEdge = commonQueryDao.findNextConditionByConditionEdge("1-2-4-1-1");
        System.out.println(JSONUtil.toJsonStr(nextConditionByConditionEdge));
    }



    @GetMapping("findItemLeafNodeVertexByItemName")
    public void findItemLeafNodeVertexByItemName(String itemName) {
        List<ItemLeaf> itemLeafNodeVertexByItemName = commonQueryDao.findItemLeafNodeVertexByItemName(itemName);
        String jsonStr = JSONUtil.toJsonStr(itemLeafNodeVertexByItemName);
        log.info(jsonStr);
    }

    @GetMapping("findItemBranchNodeVertexByItemName")
    public void findItemBranchNodeVertexByItemName(String itemName) {
        List<ItemBranch> itemBranchNodeVertexByItemName = commonQueryDao.findItemBranchNodeVertexByItemName(itemName);
        String jsonStr = JSONUtil.toJsonStr(itemBranchNodeVertexByItemName);
        log.info(jsonStr);
    }

    @GetMapping("findItemLeafByBranchId")
    public void findItemLeafByBranchId(String branchVId) {
        List<ItemLeaf> itemLeafByBranchId = commonQueryDao.findItemLeafByBranchId(branchVId);
        String jsonStr = JSONUtil.toJsonStr(itemLeafByBranchId);
        log.info(jsonStr);
    }


}
