package com.supervision.enums;

public enum RetireRoleEnum {

    sex("sex", "性别", null),
    job("job", "职业", null),
    age("age", "年龄", EntityQuestionEnum.年龄),
    residentLocation("residentLocation", "户口所在地", EntityQuestionEnum.户口所在地),
    offsiteSocialSecurityInfo("offsiteSocialSecurityInfo", "异地社保转入情况", null),
    lastInsuredPlace("lastInsuredPlace", "最后参保地", null),
    pensionPaymentPeriod("pensionPaymentPeriod", "养老缴费年限", EntityQuestionEnum.缴费年限);

    private final String code;

    private final String name;

    /**
     * 关联的实体类型
     */
    private final EntityQuestionEnum entityEnum;

    RetireRoleEnum(String code, String name, EntityQuestionEnum entityEnum) {
        this.code = code;
        this.name = name;
        this.entityEnum = entityEnum;
    }

    public String getCode() {
        return code;
    }

    public String getName() {
        return name;
    }

    public EntityQuestionEnum getEntityEnum() {
        return entityEnum;
    }
}
