package com.supervision.handler.graph;

import cn.hutool.core.collection.CollUtil;
import com.supervision.exception.BusinessException;
import com.supervision.ngbatis.dao.CommonQueryDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

@Slf4j
@Component
public class FindItemDetailHandler {

    @Resource
    private CommonQueryDao commonQueryDao;

    public List<String> findItemDetail(String itemVid, String itemType, String edgeType) {
        List<String> itemDetail = commonQueryDao.findItemDetail(itemVid, edgeType, itemType);
        if (CollUtil.isEmpty(itemDetail)){
            throw new BusinessException("未找到事项信息");
        }
        return itemDetail;
    }
}
